diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-ppdu.cc ns-3.34/src/wifi/model/wifi-ppdu.cc
--- ns-3.33/src/wifi/model/wifi-ppdu.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-ppdu.cc	2021-07-14 10:31:07.000000000 -0700
@@ -18,377 +18,67 @@
  * Author: Rediet <getachew.redieteab@orange.com>
  */
 
-#include "ns3/log.h"
-#include "ns3/packet.h"
 #include "wifi-ppdu.h"
 #include "wifi-psdu.h"
-#include "wifi-phy.h"
-#include "wifi-utils.h"
+#include "ns3/log.h"
+#include "ns3/packet.h"
 
 namespace ns3 {
 
 NS_LOG_COMPONENT_DEFINE ("WifiPpdu");
 
-WifiPpdu::WifiPpdu (Ptr<const WifiPsdu> psdu, WifiTxVector txVector, Time ppduDuration, WifiPhyBand band)
+WifiPpdu::WifiPpdu (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint64_t uid /* = UINT64_MAX */)
   : m_preamble (txVector.GetPreambleType ()),
-    m_modulation (txVector.IsValid () ? txVector.GetMode ().GetModulationClass () : WIFI_MOD_CLASS_UNKNOWN),
+    m_modulation (txVector.IsValid () ? txVector.GetModulationClass () : WIFI_MOD_CLASS_UNKNOWN),
+    m_uid (uid),
     m_truncatedTx (false),
-    m_band (band),
-    m_channelWidth (txVector.GetChannelWidth ()),
     m_txPowerLevel (txVector.GetTxPowerLevel ())
 {
-  NS_LOG_FUNCTION (this << *psdu << txVector << ppduDuration << band);
+  NS_LOG_FUNCTION (this << *psdu << txVector << uid);
   m_psdus.insert (std::make_pair (SU_STA_ID, psdu));
-  SetPhyHeaders (txVector, ppduDuration, band);
 }
 
-WifiPpdu::WifiPpdu (const WifiConstPsduMap & psdus, WifiTxVector txVector, Time ppduDuration, WifiPhyBand band)
+WifiPpdu::WifiPpdu (const WifiConstPsduMap & psdus, const WifiTxVector& txVector, uint64_t uid)
   : m_preamble (txVector.GetPreambleType ()),
     m_modulation (txVector.IsValid () ? txVector.GetMode (psdus.begin()->first).GetModulationClass () : WIFI_MOD_CLASS_UNKNOWN),
-    m_psdus (psdus),
+    m_uid (uid),
     m_truncatedTx (false),
-    m_band (band),
-    m_channelWidth (txVector.GetChannelWidth ()),
-    m_txPowerLevel (txVector.GetTxPowerLevel ())
+    m_txPowerLevel (txVector.GetTxPowerLevel ()),
+    m_txAntennas (txVector.GetNTx ())
 {
-  NS_LOG_FUNCTION (this << psdus << txVector << ppduDuration << band);
-  if (m_preamble == WIFI_PREAMBLE_HE_MU)
-    {
-      m_muUserInfos = txVector.GetHeMuUserInfoMap ();
-    }
-  SetPhyHeaders (txVector, ppduDuration, band);
+  NS_LOG_FUNCTION (this << psdus << txVector << uid);
+  m_psdus = psdus;
 }
 
 WifiPpdu::~WifiPpdu ()
 {
-}
-
-void
-WifiPpdu::SetPhyHeaders (WifiTxVector txVector, Time ppduDuration, WifiPhyBand band)
-{
-  if (!txVector.IsValid ())
-    {
-      return;
-    }
-  NS_LOG_FUNCTION (this << txVector << ppduDuration << band);
-  switch (m_modulation)
+  for (auto & psdu : m_psdus)
     {
-      case WIFI_MOD_CLASS_DSSS:
-      case WIFI_MOD_CLASS_HR_DSSS:
-        {
-          NS_ASSERT (m_psdus.size () == 1);
-          m_dsssSig.SetRate (txVector.GetMode ().GetDataRate (22));
-          Time psduDuration = ppduDuration - WifiPhy::CalculatePhyPreambleAndHeaderDuration (txVector);
-          m_dsssSig.SetLength (psduDuration.GetMicroSeconds ());
-          break;
-        }
-      case WIFI_MOD_CLASS_OFDM:
-      case WIFI_MOD_CLASS_ERP_OFDM:
-        {
-          NS_ASSERT (m_psdus.size () == 1);
-          m_lSig.SetRate (txVector.GetMode ().GetDataRate (txVector), m_channelWidth);
-          m_lSig.SetLength (m_psdus.at (SU_STA_ID)->GetSize ());
-          break;
-        }
-      case WIFI_MOD_CLASS_HT:
-        {
-          NS_ASSERT (m_psdus.size () == 1);
-          uint8_t sigExtension = 0;
-          if (m_band == WIFI_PHY_BAND_2_4GHZ)
-            {
-              sigExtension = 6;
-            }
-          uint16_t length = ((ceil ((static_cast<double> (ppduDuration.GetNanoSeconds () - (20 * 1000) - (sigExtension * 1000)) / 1000) / 4.0) * 3) - 3);
-          m_lSig.SetLength (length);
-          m_htSig.SetMcs (txVector.GetMode ().GetMcsValue ());
-          m_htSig.SetChannelWidth (m_channelWidth);
-          m_htSig.SetHtLength (m_psdus.at (SU_STA_ID)->GetSize ());
-          m_htSig.SetAggregation (txVector.IsAggregation ());
-          m_htSig.SetShortGuardInterval (txVector.GetGuardInterval () == 400);
-          m_htSig.SetFecCoding (txVector.IsLdpc ());
-          break;
-        }
-      case WIFI_MOD_CLASS_VHT:
-        {
-          uint16_t length = ((ceil ((static_cast<double> (ppduDuration.GetNanoSeconds () - (20 * 1000)) / 1000) / 4.0) * 3) - 3);
-          m_lSig.SetLength (length);
-          m_vhtSig.SetMuFlag (m_preamble == WIFI_PREAMBLE_VHT_MU);
-          m_vhtSig.SetChannelWidth (m_channelWidth);
-          m_vhtSig.SetShortGuardInterval (txVector.GetGuardInterval () == 400);
-          uint32_t nSymbols = (static_cast<double> ((ppduDuration - WifiPhy::CalculatePhyPreambleAndHeaderDuration (txVector)).GetNanoSeconds ()) / (3200 + txVector.GetGuardInterval ()));
-          if (txVector.GetGuardInterval () == 400)
-            {
-              m_vhtSig.SetShortGuardIntervalDisambiguation ((nSymbols % 10) == 9);
-            }
-          m_vhtSig.SetSuMcs (txVector.GetMode ().GetMcsValue ());
-          m_vhtSig.SetNStreams (txVector.GetNss ());
-          m_vhtSig.SetCoding (txVector.IsLdpc ());
-          break;
-        }
-      case WIFI_MOD_CLASS_HE:
-        {
-          uint8_t sigExtension = 0;
-          if (m_band == WIFI_PHY_BAND_2_4GHZ)
-            {
-              sigExtension = 6;
-            }
-          uint8_t m = 0;
-          if ((m_preamble == WIFI_PREAMBLE_HE_SU) || (m_preamble == WIFI_PREAMBLE_HE_TB))
-            {
-              m = 2;
-            }
-          else if (m_preamble == WIFI_PREAMBLE_HE_MU)
-            {
-              m = 1;
-            }
-          else
-            {
-              NS_ASSERT_MSG (false, "Unsupported preamble type");
-            }
-          uint16_t length = ((ceil ((static_cast<double> (ppduDuration.GetNanoSeconds () - (20 * 1000) - (sigExtension * 1000)) / 1000) / 4.0) * 3) - 3 - m);
-          m_lSig.SetLength (length);
-          if (m_preamble == WIFI_PREAMBLE_HE_MU)
-            {
-              m_heSig.SetMuFlag (true);
-            }
-          else if (m_preamble != WIFI_PREAMBLE_HE_TB)
-            {
-              m_heSig.SetMcs (txVector.GetMode ().GetMcsValue ());
-              m_heSig.SetNStreams (txVector.GetNss ());
-            }
-          m_heSig.SetBssColor (txVector.GetBssColor ());
-          m_heSig.SetChannelWidth (m_channelWidth);
-          m_heSig.SetGuardIntervalAndLtfSize (txVector.GetGuardInterval (), 2/*NLTF currently unused*/);
-          m_heSig.SetCoding (txVector.IsLdpc ());
-          break;
-        }
-        default:
-          NS_FATAL_ERROR ("unsupported modulation class");
-          break;
+      psdu.second = 0;
     }
+  m_psdus.clear ();
 }
 
 WifiTxVector
 WifiPpdu::GetTxVector (void) const
 {
-  WifiTxVector txVector;
-  txVector.SetPreambleType (m_preamble);
-  switch (m_modulation)
-    {
-      case WIFI_MOD_CLASS_DSSS:
-      case WIFI_MOD_CLASS_HR_DSSS:
-        {
-          WifiMode mode;
-          switch (m_dsssSig.GetRate ())
-            {
-              case 1000000:
-                mode = WifiPhy::GetDsssRate1Mbps ();
-                break;
-              case 2000000:
-                mode = WifiPhy::GetDsssRate2Mbps ();
-                break;
-              case 5500000:
-                mode = WifiPhy::GetDsssRate5_5Mbps ();
-                break;
-              case 11000000:
-                mode = WifiPhy::GetDsssRate11Mbps ();
-                break;
-              default:
-                NS_ASSERT_MSG (false, "Invalid rate encoded in DSSS SIG header");
-                break;
-            }
-          txVector.SetMode (mode);
-          txVector.SetChannelWidth (22);
-          break;
-        }
-      case WIFI_MOD_CLASS_OFDM:
-        {
-          WifiMode mode;
-          switch (m_lSig.GetRate (m_channelWidth))
-            {
-              case 1500000:
-                mode = WifiPhy::GetOfdmRate1_5MbpsBW5MHz ();
-                break;
-              case 2250000:
-                mode = WifiPhy::GetOfdmRate2_25MbpsBW5MHz ();
-                break;
-              case 3000000:
-                mode = (m_channelWidth == 5) ? WifiPhy::GetOfdmRate3MbpsBW5MHz () : WifiPhy::GetOfdmRate3MbpsBW10MHz ();
-                break;
-              case 4500000:
-                mode = (m_channelWidth == 5) ? WifiPhy::GetOfdmRate4_5MbpsBW5MHz () : WifiPhy::GetOfdmRate4_5MbpsBW10MHz ();
-                break;
-              case 6000000:
-                if (m_channelWidth == 5)
-                  {
-                    mode = WifiPhy::GetOfdmRate6MbpsBW5MHz ();
-                  }
-                else if (m_channelWidth == 10)
-                  {
-                    mode = WifiPhy::GetOfdmRate6MbpsBW10MHz ();
-                  }
-                else
-                  {
-                    mode = WifiPhy::GetOfdmRate6Mbps ();
-                  }
-                break;
-              case 9000000:
-                if (m_channelWidth == 5)
-                  {
-                    mode = WifiPhy::GetOfdmRate9MbpsBW5MHz ();
-                  }
-                else if (m_channelWidth == 10)
-                  {
-                    mode = WifiPhy::GetOfdmRate9MbpsBW10MHz ();
-                  }
-                else
-                  {
-                    mode = WifiPhy::GetOfdmRate9Mbps ();
-                  }
-                break;
-              case 12000000:
-                if (m_channelWidth == 5)
-                  {
-                    mode = WifiPhy::GetOfdmRate12MbpsBW5MHz ();
-                  }
-                else if (m_channelWidth == 10)
-                  {
-                    mode = WifiPhy::GetOfdmRate12MbpsBW10MHz ();
-                  }
-                else
-                  {
-                    mode = WifiPhy::GetOfdmRate12Mbps ();
-                  }
-                break;
-              case 13500000:
-                mode = WifiPhy::GetOfdmRate13_5MbpsBW5MHz ();
-                break;
-              case 18000000:
-                mode = (m_channelWidth == 10) ? WifiPhy::GetOfdmRate18MbpsBW10MHz () : WifiPhy::GetOfdmRate18Mbps ();
-                break;
-              case 24000000:
-                mode = (m_channelWidth == 10) ? WifiPhy::GetOfdmRate24MbpsBW10MHz () : WifiPhy::GetOfdmRate24Mbps ();
-                break;
-              case 27000000:
-                mode = WifiPhy::GetOfdmRate27MbpsBW10MHz ();
-                break;
-              case 36000000:
-                mode = WifiPhy::GetOfdmRate36Mbps ();
-                break;
-              case 48000000:
-                mode = WifiPhy::GetOfdmRate48Mbps ();
-                break;
-              case 54000000:
-                mode = WifiPhy::GetOfdmRate54Mbps ();
-                break;
-              default:
-                NS_ASSERT_MSG (false, "Invalid rate encoded in L-SIG header");
-                break;
-            }
-          txVector.SetMode (mode);
-          //OFDM uses 20 MHz, unless PHY channel width is 5 MHz or 10 MHz
-          txVector.SetChannelWidth (m_channelWidth < 20 ? m_channelWidth : 20);
-          break;
-        }
-      case WIFI_MOD_CLASS_ERP_OFDM:
-        {
-          WifiMode mode;
-          switch (m_lSig.GetRate ())
-            {
-              case 6000000:
-                mode = WifiPhy::GetErpOfdmRate6Mbps ();
-                break;
-              case 9000000:
-                mode = WifiPhy::GetErpOfdmRate9Mbps ();
-                break;
-              case 12000000:
-                mode = WifiPhy::GetErpOfdmRate12Mbps ();
-                break;
-              case 18000000:
-                mode = WifiPhy::GetErpOfdmRate18Mbps ();
-                break;
-              case 24000000:
-                mode = WifiPhy::GetErpOfdmRate24Mbps ();
-                break;
-              case 36000000:
-                mode = WifiPhy::GetErpOfdmRate36Mbps ();
-                break;
-              case 48000000:
-                mode = WifiPhy::GetErpOfdmRate48Mbps ();
-                break;
-              case 54000000:
-                mode = WifiPhy::GetErpOfdmRate54Mbps ();
-                break;
-              default:
-                NS_ASSERT_MSG (false, "Invalid rate encoded in L-SIG header");
-                break;
-            }
-          txVector.SetMode (mode);
-          //ERP-OFDM uses 20 MHz, unless PHY channel width is 5 MHz or 10 MHz
-          txVector.SetChannelWidth (m_channelWidth < 20 ? m_channelWidth : 20);
-          break;
-        }
-      case WIFI_MOD_CLASS_HT:
-        {
-          txVector.SetMode (WifiPhy::GetHtMcs (m_htSig.GetMcs ()));
-          txVector.SetChannelWidth (m_htSig.GetChannelWidth ());
-          txVector.SetNss (1 + (m_htSig.GetMcs () / 8));
-          txVector.SetGuardInterval(m_htSig.GetShortGuardInterval () ? 400 : 800);
-          txVector.SetLdpc (m_htSig.IsLdpcFecCoding ());
-          break;
-        }
-      case WIFI_MOD_CLASS_VHT:
-        {
-          txVector.SetMode (WifiPhy::GetVhtMcs (m_vhtSig.GetSuMcs ()));
-          txVector.SetChannelWidth (m_vhtSig.GetChannelWidth ());
-          txVector.SetNss (m_vhtSig.GetNStreams ());
-          txVector.SetGuardInterval (m_vhtSig.GetShortGuardInterval () ? 400 : 800);
-          txVector.SetLdpc (m_vhtSig.IsLdpcCoding ());
-          break;
-        }
-      case WIFI_MOD_CLASS_HE:
-        {
-          txVector.SetMode (WifiPhy::GetHeMcs (m_heSig.GetMcs ()));
-          txVector.SetChannelWidth (m_heSig.GetChannelWidth ());
-          txVector.SetNss (m_heSig.GetNStreams ());
-          txVector.SetGuardInterval (m_heSig.GetGuardInterval ());
-          txVector.SetBssColor (m_heSig.GetBssColor ());
-          txVector.SetLdpc (m_heSig.IsLdpcCoding ());
-          break;
-        }
-      default:
-        NS_FATAL_ERROR ("unsupported modulation class");
-        break;
-    }
+  WifiTxVector txVector = DoGetTxVector ();
   txVector.SetTxPowerLevel (m_txPowerLevel);
-  txVector.SetAggregation (m_psdus.size () > 1 || m_psdus.begin ()->second->IsAggregate ());
-  for (auto const& muUserInfo : m_muUserInfos)
-    {
-      txVector.SetHeMuUserInfo (muUserInfo.first, muUserInfo.second);
-    }
+  txVector.SetNTx (m_txAntennas);
   return txVector;
 }
 
+WifiTxVector
+WifiPpdu::DoGetTxVector (void) const
+{
+  NS_FATAL_ERROR ("This method should not be called for the base WifiPpdu class. Use the overloaded version in the amendment-specific PPDU subclasses instead!");
+  return WifiTxVector (); //should be overloaded
+}
+
 Ptr<const WifiPsdu>
-WifiPpdu::GetPsdu (uint8_t bssColor, uint16_t staId) const
+WifiPpdu::GetPsdu (void) const
 {
-  if (!IsMu ())
-    {
-      NS_ASSERT (m_psdus.size () == 1);
-      return m_psdus.at (SU_STA_ID);
-    }
-  else
-    {
-      if (bssColor == m_heSig.GetBssColor ())
-        {
-          auto it = m_psdus.find (staId);
-          if (it != m_psdus.end ())
-            {
-              return it->second;
-            }
-        }
-    }
-  return nullptr;
+  return m_psdus.begin ()->second;
 }
 
 bool
@@ -404,103 +94,108 @@
   m_truncatedTx = true;
 }
 
-Time
-WifiPpdu::GetTxDuration (void) const
+WifiModulationClass
+WifiPpdu::GetModulation (void) const
+{
+  return m_modulation;
+}
+
+uint16_t
+WifiPpdu::GetTransmissionChannelWidth (void) const
+{
+  return GetTxVector ().GetChannelWidth ();
+}
+
+bool
+WifiPpdu::CanBeReceived (uint16_t txCenterFreq, uint16_t p20MinFreq,
+                              uint16_t p20MaxFreq) const
 {
-  Time ppduDuration = Seconds (0);
-  WifiTxVector txVector = GetTxVector ();
-  switch (m_modulation)
+  NS_LOG_FUNCTION (this << txCenterFreq << p20MinFreq << p20MaxFreq);
+
+  uint16_t txChannelWidth = GetTxVector ().GetChannelWidth ();
+  uint16_t minTxFreq = txCenterFreq - txChannelWidth / 2;
+  uint16_t maxTxFreq = txCenterFreq + txChannelWidth / 2;
+
+  if (minTxFreq > p20MinFreq || maxTxFreq < p20MaxFreq)
     {
-      case WIFI_MOD_CLASS_DSSS:
-      case WIFI_MOD_CLASS_HR_DSSS:
-          ppduDuration = MicroSeconds (m_dsssSig.GetLength ()) + WifiPhy::CalculatePhyPreambleAndHeaderDuration (txVector);
-          break;
-      case WIFI_MOD_CLASS_OFDM:
-      case WIFI_MOD_CLASS_ERP_OFDM:
-          ppduDuration = WifiPhy::CalculateTxDuration (m_lSig.GetLength (), txVector, m_band);
-          break;
-      case WIFI_MOD_CLASS_HT:
-          ppduDuration = WifiPhy::CalculateTxDuration (m_htSig.GetHtLength (), txVector, m_band);
-          break;
-      case WIFI_MOD_CLASS_VHT:
-        {
-          Time tSymbol = NanoSeconds (3200 + txVector.GetGuardInterval ());
-          Time preambleDuration = WifiPhy::CalculatePhyPreambleAndHeaderDuration (txVector);
-          Time calculatedDuration = MicroSeconds (((ceil (static_cast<double> (m_lSig.GetLength () + 3) / 3)) * 4) + 20);
-          uint32_t nSymbols = floor (static_cast<double> ((calculatedDuration - preambleDuration).GetNanoSeconds ()) / tSymbol.GetNanoSeconds ());
-          if (m_vhtSig.GetShortGuardInterval () && m_vhtSig.GetShortGuardIntervalDisambiguation ())
-            {
-              nSymbols--;
-            }
-          ppduDuration = preambleDuration + (nSymbols * tSymbol);
-          break;
-        }
-      case WIFI_MOD_CLASS_HE:
-        {
-          Time tSymbol = NanoSeconds (12800 + txVector.GetGuardInterval ());
-          Time preambleDuration = WifiPhy::CalculatePhyPreambleAndHeaderDuration (txVector);
-          uint8_t sigExtension = 0;
-          if (m_band == WIFI_PHY_BAND_2_4GHZ)
-            {
-              sigExtension = 6;
-            }
-          uint8_t m = 0;
-          if ((m_preamble == WIFI_PREAMBLE_HE_SU) || (m_preamble == WIFI_PREAMBLE_HE_TB))
-            {
-              m = 2;
-            }
-          else if (m_preamble == WIFI_PREAMBLE_HE_MU)
-            {
-              m = 1;
-            }
-          //Equation 27-11 of IEEE P802.11ax/D4.0
-          Time calculatedDuration = MicroSeconds (((ceil (static_cast<double> (m_lSig.GetLength () + 3 + m) / 3)) * 4) + 20 + sigExtension);
-          uint32_t nSymbols = floor (static_cast<double> ((calculatedDuration - preambleDuration).GetNanoSeconds () - (sigExtension * 1000)) / tSymbol.GetNanoSeconds ());
-          ppduDuration = preambleDuration + (nSymbols * tSymbol) + MicroSeconds (sigExtension);
-          break;
-        }
-      default:
-        NS_FATAL_ERROR ("unsupported modulation class");
-        break;
+      NS_LOG_INFO ("Received PPDU does not overlap with the primary20 channel");
+      return false;
     }
-  return ppduDuration;
+  return true;
 }
 
-bool
-WifiPpdu::IsMu (void) const
+
+uint64_t
+WifiPpdu::GetUid (void) const
 {
-  return ((m_preamble == WIFI_PREAMBLE_VHT_MU) || (m_preamble == WIFI_PREAMBLE_HE_MU) || (m_preamble == WIFI_PREAMBLE_HE_TB));
+  return m_uid;
 }
 
-WifiModulationClass
-WifiPpdu::GetModulation (void) const
+WifiPreamble
+WifiPpdu::GetPreamble (void) const
 {
-  return m_modulation;
+  return m_preamble;
+}
+
+WifiPpduType
+WifiPpdu::GetType (void) const
+{
+  return WIFI_PPDU_TYPE_SU;
+}
+
+uint16_t
+WifiPpdu::GetStaId (void) const
+{
+  return SU_STA_ID;
+}
+
+Time
+WifiPpdu::GetTxDuration (void) const
+{
+  NS_FATAL_ERROR ("This method should not be called for the base WifiPpdu class. Use the overloaded version in the amendment-specific PPDU subclasses instead!");
+  return MicroSeconds (0); //should be overloaded
 }
 
 void
 WifiPpdu::Print (std::ostream& os) const
 {
-  os << "preamble=" << m_preamble
+  os << "[ preamble=" << m_preamble
      << ", modulation=" << m_modulation
-     << ", truncatedTx=" << (m_truncatedTx ? "Y" : "N");
-  IsMu () ? (os << ", " << m_psdus) : (os << ", PSDU=" << m_psdus.at (SU_STA_ID));
+     << ", truncatedTx=" << (m_truncatedTx ? "Y" : "N")
+     << ", UID=" << m_uid
+     << ", " << PrintPayload ()
+     << "]";
+}
+
+std::string
+WifiPpdu::PrintPayload (void) const
+{
+  std::ostringstream ss;
+  ss << "PSDU=" << GetPsdu () << " ";
+  return ss.str ();
+}
+
+Ptr<WifiPpdu>
+WifiPpdu::Copy (void) const
+{
+  NS_FATAL_ERROR ("This method should not be called for the base WifiPpdu class. Use the overloaded version in the amendment-specific PPDU subclasses instead!");
+  return Create<WifiPpdu> (GetPsdu (), GetTxVector ());
 }
 
-std::ostream & operator << (std::ostream &os, const WifiPpdu &ppdu)
+std::ostream & operator << (std::ostream &os, const Ptr<const WifiPpdu> &ppdu)
 {
-  ppdu.Print (os);
+  ppdu->Print (os);
   return os;
 }
 
 std::ostream & operator << (std::ostream &os, const WifiConstPsduMap &psdus)
 {
   for (auto const& psdu : psdus)
-    {
-      os << "PSDU for STA_ID=" << psdu.first
-         << " (" << *psdu.second << ") ";
-    }
-  return os;
+   {
+     os << "PSDU for STA_ID=" << psdu.first
+        << " (" << *psdu.second << ") ";
+   }
+   return os;
 }
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-ppdu.h ns-3.34/src/wifi/model/wifi-ppdu.h
--- ns-3.33/src/wifi/model/wifi-ppdu.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-ppdu.h	2021-07-14 10:31:07.000000000 -0700
@@ -21,67 +21,73 @@
 #ifndef WIFI_PPDU_H
 #define WIFI_PPDU_H
 
+#include "wifi-tx-vector.h"
+#include "ns3/nstime.h"
 #include <list>
 #include <unordered_map>
-#include "ns3/nstime.h"
-#include "wifi-tx-vector.h"
-#include "wifi-phy-header.h"
-#include "wifi-phy-band.h"
+
+/**
+ * \file
+ * \ingroup wifi
+ * Declaration of ns3::WifiPpdu class
+ * and ns3::WifiConstPsduMap.
+ */
 
 namespace ns3 {
 
 class WifiPsdu;
 
-typedef std::unordered_map <uint16_t /* staId */, Ptr<const WifiPsdu> /* PSDU */> WifiConstPsduMap;
+/**
+ * Map of const PSDUs indexed by STA-ID
+ */
+typedef std::unordered_map <uint16_t /* STA-ID */, Ptr<const WifiPsdu> /* PSDU */> WifiConstPsduMap;
 
 /**
  * \ingroup wifi
  *
  * WifiPpdu stores a preamble, a modulation class, PHY headers and a PSDU.
- * This class should be extended later on to handle MU PPDUs.
+ * This class should be subclassed for each amendment.
  */
 class WifiPpdu : public SimpleRefCount<WifiPpdu>
 {
 public:
   /**
-   * Create a SU PPDU storing a PSDU.
+   * Create a PPDU storing a PSDU.
    *
    * \param psdu the PHY payload (PSDU)
    * \param txVector the TXVECTOR that was used for this PPDU
-   * \param ppduDuration the transmission duration of this PPDU
-   * \param band the WifiPhyBand used for the transmission of this PPDU
+   * \param uid the unique ID of this PPDU
    */
-  WifiPpdu (Ptr<const WifiPsdu> psdu, WifiTxVector txVector, Time ppduDuration, WifiPhyBand band);
-
+  WifiPpdu (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint64_t uid = UINT64_MAX);
   /**
-   * Create a MU PPDU storing a vector of PSDUs.
+   * Create a PPDU storing a map of PSDUs.
    *
    * \param psdus the PHY payloads (PSDUs)
    * \param txVector the TXVECTOR that was used for this PPDU
-   * \param ppduDuration the transmission duration of this PPDU
-   * \param band the WifiPhyBand used for the transmission of this PPDU
+   * \param uid the unique ID of this PPDU
+   */
+  WifiPpdu (const WifiConstPsduMap & psdus, const WifiTxVector& txVector, uint64_t uid);
+  /**
+   * Destructor for WifiPpdu.
    */
-  WifiPpdu (const WifiConstPsduMap & psdus, WifiTxVector txVector, Time ppduDuration, WifiPhyBand band);
-
   virtual ~WifiPpdu ();
 
   /**
    * Get the TXVECTOR used to send the PPDU.
+   *
    * \return the TXVECTOR of the PPDU.
    */
   WifiTxVector GetTxVector (void) const;
 
   /**
    * Get the payload of the PPDU.
-   * \param bssColor the BSS color of the PHY calling this function.
-   * \param staId the staId of the PHY calling this function.
+   *
    * \return the PSDU
    */
-  Ptr<const WifiPsdu> GetPsdu (uint8_t bssColor = 64, uint16_t staId = SU_STA_ID) const;
+  Ptr<const WifiPsdu> GetPsdu (void) const;
 
   /**
-   * Return true if the PPDU's transmission was aborted due to transmitter switch off
-   * \return true if the PPDU's transmission was aborted due to transmitter switch off
+   * \return c\ true if the PPDU's transmission was aborted due to transmitter switch off
    */
   bool IsTruncatedTx (void) const;
 
@@ -92,15 +98,34 @@
 
   /**
    * Get the total transmission duration of the PPDU.
+   *
    * \return the transmission duration of the PPDU
    */
-  Time GetTxDuration () const;
+  virtual Time GetTxDuration (void) const;
+
+  /**
+   * Get the channel width over which the PPDU will effectively be
+   * transmitted.
+   *
+   * \param ppdu the PPDU to send
+   * \return the effective channel width (in MHz) used for the tranmsission
+   */
+  virtual uint16_t GetTransmissionChannelWidth (void) const;
 
   /**
-   * Return true if the PPDU is a MU PPDU
-   * \return true if the PPDU is a MU PPDU
+   * Check whether the given PPDU can be received on the specified primary
+   * channel. Normally, a PPDU can be received if it is transmitted over a
+   * channel that overlaps the primary20 channel of a PHY entity.
+   *
+   * \param ppdu the given PPDU
+   * \param txCenterFreq the center frequency (MHz) of the channel over which the
+   *        PPDU is transmitted
+   * \param p20MinFreq the minimum frequency (MHz) of the primary channel
+   * \param p20MaxFreq the maximum frequency (MHz) of the primary channel
+   * \return true if this PPDU can be received, false otherwise
    */
-  bool IsMu (void) const;
+  virtual bool CanBeReceived (uint16_t txCenterFreq, uint16_t p20MinFreq,
+                              uint16_t p20MaxFreq) const;
 
   /**
    * Get the modulation used for the PPDU.
@@ -109,45 +134,74 @@
   WifiModulationClass GetModulation (void) const;
 
   /**
+   * Get the UID of the PPDU.
+   * \return the UID of the PPDU
+   */
+  uint64_t GetUid (void) const;
+
+  /**
+   * Get the preamble of the PPDU.
+   * \return the preamble of the PPDU
+   */
+  WifiPreamble GetPreamble (void) const;
+
+  /**
    * \brief Print the PPDU contents.
    * \param os output stream in which the data should be printed.
    */
   void Print (std::ostream &os) const;
+  /**
+   * \brief Copy this instance.
+   * \return a Ptr to a copy of this instance.
+   */
+  virtual Ptr<WifiPpdu> Copy (void) const;
 
+  /**
+   * Return the PPDU type (\see WifiPpduType)
+   * \return the PPDU type
+   */
+  virtual WifiPpduType GetType (void) const;
+
+  /**
+   * Get the ID of the STA that transmitted the PPDU for UL MU,
+   * SU_STA_ID otherwise.
+   * \return the ID of the STA that transmitted the PPDU for UL MU, SU_STA_ID otherwise
+   */
+  virtual uint16_t GetStaId (void) const;
+
+protected:
+  /**
+   * \brief Print the payload of the PPDU.
+   * \return information on the payload part of the PPDU
+   */
+  virtual std::string PrintPayload (void) const;
+
+  WifiPreamble m_preamble;          //!< the PHY preamble
+  WifiModulationClass m_modulation; //!< the modulation used for the transmission of this PPDU
+  WifiConstPsduMap m_psdus;         //!< the PSDUs contained in this PPDU
+  uint64_t m_uid;                   //!< the unique ID of this PPDU
 
 private:
   /**
-   * Fill in the PHY headers.
+   * Get the TXVECTOR used to send the PPDU.
    *
-   * \param txVector the TXVECTOR that was used for this PPDU
-   * \param ppduDuration the transmission duration of this PPDU
-   * \param band the WifiPhyBand used for the transmission of this PPDU
+   * \return the TXVECTOR of the PPDU.
    */
-  void SetPhyHeaders (WifiTxVector txVector, Time ppduDuration, WifiPhyBand band);
+  virtual WifiTxVector DoGetTxVector (void) const;
 
-  DsssSigHeader m_dsssSig;                     //!< the DSSS SIG PHY header
-  LSigHeader m_lSig;                           //!< the L-SIG PHY header
-  HtSigHeader m_htSig;                         //!< the HT-SIG PHY header
-  VhtSigHeader m_vhtSig;                       //!< the VHT-SIG PHY header
-  HeSigHeader m_heSig;                         //!< the HE-SIG PHY header
-  WifiPreamble m_preamble;                     //!< the PHY preamble
-  WifiModulationClass m_modulation;            //!< the modulation used for the transmission of this PPDU
-  WifiConstPsduMap m_psdus;                    //!< the PSDUs contained in this PPDU
-  bool m_truncatedTx;                          //!< flag indicating whether the frame's transmission was aborted due to transmitter switch off
-  WifiPhyBand m_band;                          //!< the WifiPhyBand used to transmit that PPDU
-  uint16_t m_channelWidth;                     //!< the channel width used to transmit that PPDU in MHz
-  uint8_t m_txPowerLevel;                      //!< the transmission power level (used only for TX and initializing the returned WifiTxVector)
-  WifiTxVector::HeMuUserInfoMap m_muUserInfos; //!< the HE MU specific per-user information (to be removed once HE-SIG-B headers are implemented)
-};
+  bool m_truncatedTx;     //!< flag indicating whether the frame's transmission was aborted due to transmitter switch off
+  uint8_t m_txPowerLevel; //!< the transmission power level (used only for TX and initializing the returned WifiTxVector)
+  uint8_t m_txAntennas;   //!< the number of antennas used to transmit this PPDU
+}; //class WifiPpdu
 
 /**
  * \brief Stream insertion operator.
  *
  * \param os the stream
- * \param ppdu the PPDU
+ * \param ppdu the const pointer to the PPDU
  * \returns a reference to the stream
  */
-std::ostream& operator<< (std::ostream& os, const WifiPpdu &ppdu);
+std::ostream& operator<< (std::ostream& os, const Ptr<const WifiPpdu> &ppdu);
 
 /**
  * \brief Stream insertion operator.
